About ps -ef and if-else problems


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting About ps -ef and if-else problems
# 1  
Old 11-29-2012
About ps -ef and if-else problems

I'm new in Shell Programming and Scripting, I would like to ask some questions.
Code:
ps -ef | grep $appNAme | grep -v grep <-- what will it return when it find a process is running? return 1 or 0

if [ $? -ne 1 ]
then
      exit 1  <--- if  = 0 , run this ?
else
      continue <---  if  = 1 , run this ?
fi

Am I right? Thank you for your attention.

Moderator's Comments:
Mod Comment Please use code tags when posting code, data or logs etc., thanks.

Last edited by zaxxon; 11-29-2012 at 04:24 AM.. Reason: code tags
# 2  
Old 11-29-2012
When it finds a process with "grep" in it, it will be always 0, no matter what process you are looking for.
You should 1st use grep -v grep to filter out the line and then check for that process. You will then get the correct return code you are looking for.
# 3  
Old 11-29-2012
1) In case of a pipeline, the exit status is that of the last command (unless the shell supports the pipefail option and that is set). So, the exit status is that of grep -v grep, which will be 0 if it anything passes through this grep command to standard output.
In short, if the process is running, this will return a 0 (success).

2) No. That means if not 1 which might not be the same as if 0.

3) Yes.
# 4  
Old 11-29-2012
1) If you have commands like pgrep/pkill then use it. This should be better.

2) $? is not always 1 or 0.(As pointed above)

3) And you can use simply like this..

Code:
if [[ $(pgrep "$process_name" ]]
then
echo "process running"
else
echo "process not running"
fi

# 5  
Old 11-29-2012
Thanks all guys......Smilie
# 6  
Old 11-29-2012
You can also use pidof "process"
If its anything but 0, then its running
Login or Register to Ask a Question

Previous Thread | Next Thread

9 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

If/then problems

#! /bin/bash # ask what the user would like to do CMD=$CMD MBA=$MB RS=$RS CT=$CT echo echo -n "What would you like to do?? REMEMBER WHEN PROGRAMMING ICP's TO SELECT CORRECT COMMAND ACCORDING TO NECCESSARY TYPE CODE! Please enter a command ct = program ctek ... (5 Replies)
Discussion started by: tdalyman
5 Replies

2. UNIX for Dummies Questions & Answers

Problems with IF Else ??!!

I have written the following code in cygwin to create directories in windows based on the parameter passed. echo $1 > fullpath path1=`awk -F / '{print $1}' $fullpath path2=`awk -F / '{print $2}' $fullpath if then if then if then continue ... (4 Replies)
Discussion started by: janardhanamk
4 Replies

3. SuSE

Problems!!

good friends I am new to linux and I have the following TELNET service problem entering data devo telnet to a Windows server 2003 server and passes will not let me since the move to this server by telnet tells me the characters and thus invalidates me income, I have a service application... (1 Reply)
Discussion started by: pepetico
1 Replies

4. Shell Programming and Scripting

Problems with $?

Hello, I have the following piece of code that tries to retrieve the result of a .sh: . $HOME/prueba/Scripts/Recogida/recogida_sedra.sh resultado=$? echo "el resultado es : $resultado" if ; then echo "Se va a preprocesar los archivos" In the code of recogida.sh I have the... (8 Replies)
Discussion started by: danietepa
8 Replies

5. UNIX for Dummies Questions & Answers

Problems with using less

Hello, I am having problems with using less on Linux version 2.6.18-92.1.17.el5 (brewbuilder@hs20-bc1-7.build.redhat.com) (gcc version 4.1.2 20071124 (Red Hat 4.1.2-42)). I am using csh but have the same problems on bash. If I pipe something to less it works perfectly i.e. cat file | less... (9 Replies)
Discussion started by: z1dane
9 Replies

6. UNIX for Dummies Questions & Answers

problems with If

I'm having problems uses "if" it works fine when i do this. #!/bin/sh a= 10 qw= 2 w= 20 { if && ;then echo 3 fi } However if i try to do #!/bin/sh a= 10 (5 Replies)
Discussion started by: THM
5 Replies

7. UNIX for Advanced & Expert Users

Problems with Last

Hi, I,ve a Unixware 7.1.3 working correctly for two years ago, since a several weeks I've a problem with the command last . The information that this command return is : For example : 1.- The user root , time login : 12:15 h, time logoff 12:15 h (the real time is 14:00). Connected time is... (3 Replies)
Discussion started by: By_Jam
3 Replies

8. UNIX for Dummies Questions & Answers

Few problems

Hi how can i do this? 1) shell script which writes data and time on to a file if filesystem exceeds 70% of space. 2) make entry to cron table to run a script every 15 mins. and can anyone expplain or demonstrate the difference between variables used in inside a function and outside a... (3 Replies)
Discussion started by: vivekshankar
3 Replies

9. UNIX for Advanced & Expert Users

'make' problems (compliation problems?)

I'm trying to compile and install both most recent version of 'make' and the most recent version of 'openssh' on my Sparc20. I've run into the following problems... and I don't know what they mean. Can someone please help me resolve these issues? I'm using the 'make' version that was... (5 Replies)
Discussion started by: xyyz
5 Replies
Login or Register to Ask a Question